; Analyze register access and modification, also combine equivalent equate and
;  offset lexemes.

;
; DATA
;
align 4

c3asciiwordxtbl db      C0MAXTOKEN dup(?)
c3asciiwordtbl  db      C0MAXTOKEN dup(?)

c3regsmodified  db      ?               ; bitmap of regs written by statement

c3err0          db      'Double assignment to register.',CRLFT

;
; CODE
;

;
_c3:
        mov edi,offset c3asciiwordtbl
        mov ecx,C0MAXTOKEN
        xor al,al
        rep stosb
        mov ebp,1
c3l1:
        mov eax,c0token[ebp*4]
        cmp al,EOL
        je short c3l1d
        cmp al,ASCIIWORD
        jne short c3l1c
        xor edx,edx
c3l2:
        movzx eax,c3asciiwordtbl[edx]
        or eax,eax
        jz short c3l2d
        mov ecx,c0tokenllen[ebp*4]
        cmp ecx,c0tokenllen[eax*4]
        jne short c3l2c
        mov edi,c0tokenlptr[ebp*4]
        mov esi,c0tokenlptr[eax*4]
        repe cmpsb
        je short c3l1f0
c3l2c:
        inc edx
        jmp c3l2
c3l2d:
        mov eax,ebp
        mov c3asciiwordtbl[edx],al
c3l1f0:
        mov c3asciiwordxtbl[ebp],dl
c3l1c:
        inc ebp
        jmp c3l1
c3l1d:

        mov c3regsmodified,0
        mov ebp,offset c1ins
c3l0:
        mov al,[ebp]
        cmp al,C1EOL
        je short c3l0d
        cmp al,C1MOV
        jne short c3l0c
        lea edi,[ebp+2]
        call c3r0
        jnc short c3l0f0
        mov edx,offset c3err0
        test c3regsmodified,al
        jnz c1_error
        or c3regsmodified,al
        not al
        and c0regspreserve,al
c3l0f0:
        lea edi,[ebp+12]
        call c3r0
c3l0c:
        add ebp,22
        jmp c3l0
c3l0d:
        clc
        ret

;
c3r0:
        movzx eax,byte ptr [edi+4]
        call c3r1
        mov [edi+4],al
        mov al,[edi+5]
        call c3r1
        mov [edi+5],al

        cmp byte ptr [edi],1
        jnc _ret
        mov cl,[edi+3]
        sub cl,1
        cmp cl,7
        jnc _ret
        mov al,1
        shl al,cl
        stc
        ret
;-----------------------------------------------------------------------------
c3r1:
        or al,al
        jz _ret
        mov al,c3asciiwordxtbl[eax]
        mov al,c3asciiwordtbl[eax]
        ret

