        .386p
code32  segment para public use32
        assume cs:code32, ds:code32

include pmode.inc
include file.inc
include argc.inc
include calex.inc

public  _main

DEBUG           = 0

;
; DATA
;
align 4

cslinestotal    dw      0
cslinesfine     dw      0

ofnm            db      80h dup(?)
ifnm            db      80h dup(?)

c4straddxideal  db      14,'[dword ptr ds:',14,'[dword ptr ss:'

intromsg        db      'ASM compound statement precompiler v1.21 - by Tran.',CRLFT
donemsg         db      'Compiled _____ of _____ compound statements successfully.',CRLFT
syntaxmsg       db      'SYNTAX: CA <infile> <outfile>',CRLFT

;
; CODE
;

include loadfile.rt
include hexw2bcd.rt
include pdosmsg.rt

include caio.m
include c0.m
include c1.m
include c2.m
include c3.m
include c4.m
include c5.m
if DEBUG eq 1
include p.m
endif

;
putdecnum:
        rol eax,16
        add al,'0'
        mov [edx],al
        rol eax,4
        and al,0fh
        add al,'0'
        mov [edx+1],al
        rol eax,4
        and al,0fh
        add al,'0'
        mov [edx+2],al
        rol eax,4
        and al,0fh
        add al,'0'
        mov [edx+3],al
        rol eax,4
        and al,0fh
        add al,'0'
        mov [edx+4],al
        ret

;
_main:
        sti

        mov edx,offset intromsg
        call _putdosmsg

        mov al,'i'
        call _cchekswitchnc
        jc short f1
        mov edi,offset c4straddxlds
        mov esi,offset c4straddxideal
        mov ecx,30
        rep movsb

f1:
        movzx eax,_filebuflen
        call _getlomem
        mov edx,offset ferr0
        jc _io_fatalerror
        mov _filebufloc,eax

        mov edx,offset ofnm
        mov al,1
        call _cchekstr
        jnc short f0
        mov edx,offset syntaxmsg
        call _putdosmsg
        jmp _exit
f0:
        mov edx,offset ifnm
        xor al,al
        call _cchekstr

        call _io_init

l0:
        call _c0
        jc l0d
        call _c1
        jc l0
        call _c3
        jc l0
if DEBUG ne 0
        mov edi,_ioocurptr
        mov dword ptr [edi],'eG ;'
        mov dword ptr [edi+4],'aren'
        mov dword ptr [edi+8],':det'
        mov word ptr [edi+12],0a0dh
        add edi,14
        mov _ioocurptr,edi
        call p
endif
        call _c2
        jc l0
if DEBUG ne 0
        mov edi,_ioocurptr
        mov dword ptr [edi],'pO ;'
        mov dword ptr [edi+4],'imit'
        mov dword ptr [edi+8],':dez'
        mov word ptr [edi+12],0a0dh
        add edi,14
        mov _ioocurptr,edi
        call p
        mov edi,_ioocurptr
        mov dword ptr [edi],'iF ;'
        mov dword ptr [edi+4],':lan'
        mov word ptr [edi+8],0a0dh
        add edi,10
        mov _ioocurptr,edi
endif
        call _c5
        call _c4
        inc cslinesfine
        jmp l0
l0d:

        mov edx,offset ofnm
        call _io_done

        mov edx,offset donemsg+18
        mov ax,cslinestotal
        call _cvhexw2bcd
        call putdecnum
        sub edx,9
        mov ax,cslinesfine
        call _cvhexw2bcd
        call putdecnum
        sub edx,9
        call _putdosmsg

        jmp _exit

code32  ends
        end

