
;
; DATA
;
regname         db      'eax ','ebx ','ecx ','edx ','esi ','edi ','ebp '

insname         db      '...     '
                db      'abs     '
                db      'neg     '
                db      'not     '
                db      'imul    '
                db      'idiv    '
                db      'mul     '
                db      'div     '
                db      'mod     '
                db      'add     '
                db      'sub     '
                db      'shl     '
                db      'shr     '
                db      'sar     '
                db      'rol     '
                db      'ror     '
                db      'and     '
                db      'xor     '
                db      'or      '
                db      'mov     '

hextbl          db      '0123456789abcdef'

putplus         db      ?

;
; CODE
;

;
pp:
        mov putplus,0
        cmp byte ptr [ebp],0
        je short ppf0
        mov byte ptr [edi],'['
        inc edi
ppf0:
        lea esi,[ebp+1]
        call pp1
        movzx ecx,byte ptr [esi]
        inc esi
        or ecx,ecx
        jz short ppf2
        mov byte ptr [edi],'*'
        inc edi
        mov al,1
        shl al,cl
        add al,'0'
        stosb
ppf2:
        call pp1
        movzx esi,byte ptr [ebp+4]
        or esi,esi
        jz short ppf3
        call pp0
        mov dword ptr [edi],'sffo'
        mov dword ptr [edi+4],'  te'
        add edi,7
        mov ecx,c0tokenllen[esi*4]
        mov esi,c0tokenlptr[esi*4]
        rep movsb
ppf3:
        movzx esi,byte ptr [ebp+5]
        or esi,esi
        jz short ppf4
        call pp0
        mov ecx,c0tokenllen[esi*4]
        mov esi,c0tokenlptr[esi*4]
        rep movsb
ppf4:
        mov edx,dword ptr [ebp+6]
        cmp putplus,0
        je short ppf6
        or edx,edx
        jz short ppf5
        call pp0
ppf6:
        mov byte ptr [edi],'0'
        inc edi
        mov ecx,8
ppl0:
        rol edx,4
        movzx eax,dl
        and al,0fh
        mov al,hextbl[eax]
        stosb
        loop ppl0
        mov byte ptr [edi],'h'
        inc edi
ppf5:
        cmp byte ptr [ebp],0
        je short ppf1
        mov byte ptr [edi],']'
        inc edi
ppf1:
        ret
;-----------------------------------------------------------------------------
pp0:
        cmp putplus,0
        je short pp0f0
        mov byte ptr [edi],'+'
        inc edi
pp0f0:
        mov putplus,1
        ret
;-----------------------------------------------------------------------------
pp1:
        movzx eax,byte ptr [esi]
        inc esi
        or al,al
        je _ret
        call pp0
        cmp al,7
        ja short pp1f0
        mov eax,dword ptr regname[eax*4-4]
        mov [edi],eax
        add edi,3
        ret
pp1f0:
        mov dword ptr [edi],'_pmt'
        add al,'A'-8
        mov [edi+4],al
        add edi,5
        ret

;
pr0:
        movzx esi,byte ptr [ebp]
        mov dword ptr [edi],'   ;'
        mov dword ptr [edi+4],'    '
        add edi,8
        lea esi,[esi*8-8+offset insname]
        movsd
        movsd

        add ebp,2
        cmp byte ptr [ebp-2],C1NOP
        je short pr0f1
        call pp
        add ebp,10
        cmp byte ptr [ebp-12],C1NOT
        jbe short pr0f0
        mov byte ptr [edi],','
        inc edi
        call pp
pr0f0:
        add ebp,10
        mov word ptr [edi],0a0dh
        add edi,2
        ret
pr0f1:
        add ebp,10
        jmp pr0f0

;
p:
        mov edi,_ioocurptr
        mov ebp,offset c1ins
pl0:
        cmp byte ptr [ebp],C1EOL
        je short pl0d
        call pr0
        jmp pl0
pl0d:
        mov _ioocurptr,edi
        ret

;
p2p:
        mov eax,'    '
        movzx edx,byte ptr [esi+11]
        or dl,dl
        jz short p2pf1
        cmp dl,0f8h
        ja short p2pf2
        cmp dl,8
        jae short p2pf3
        mov eax,dword ptr regname[edx*4-4]
        jmp short p2pf1
p2pf2:
        and dl,7
        mov eax,dword ptr regname[edx*4-4]
        and eax,0ffdfdfdfh
        jmp short p2pf1
p2pf3:
        add dl,'A'-8
        mov dh,' '
        shrd eax,edx,16
        mov ax,'__'
p2pf1:
        mov [edi],eax
        add edi,4
        cmp byte ptr [esi+10],0
        je short p2pf0
        mov ebp,esi
        push esi
        call pp
        pop esi
p2pf0:
        mov word ptr [edi],0a0dh
        add edi,2
        ret

;
p2:
        push ebp
        mov edi,_ioocurptr
        mov dword ptr [edi],'eR ;'
        mov dword ptr [edi+4],0d000000h+':sg'
        mov byte ptr [edi+8],0ah
        add edi,9
        xor esi,esi
p2l0:
        mov dword ptr [edi],'   ;'
        mov eax,dword ptr regname[esi*4]
        and eax,0dfdfdfh
        or eax,'-' shl 24
        mov [edi+4],eax
        add edi,8
        push esi
        lea esi,[esi*2+esi]
        lea esi,[esi*4+offset c4reg]
        call p2p
        pop esi
        inc esi
        cmp esi,7
        jb p2l0
        movzx esi,c4stacktop
        sub esi,1
        jc short p2d
        mov dword ptr [edi],'tS ;'
        mov dword ptr [edi+4],':kca'
        mov word ptr [edi+8],0a0dh
        add edi,10
        xor eax,eax
p2l1:
        push eax esi
        mov dword ptr [edi],'   ;'
        add edi,4
        mov _ioocurptr,edi
        call c4putnum
        mov byte ptr [edi+10],'-'
        add edi,11
        lea esi,[esi*2+esi]
        lea esi,[esi*4+offset c4stack]
        call p2p
        pop esi eax
        add eax,4
        sub esi,1
        jnc p2l1
p2d:
        mov _ioocurptr,edi
        pop ebp
        ret

